import Taro from '@tarojs/taro'
import { View, Text } from '@tarojs/components'
import './index.less'

interface Props{
  isOpen: boolean,
  setIsOpen: (isOpen: boolean) => void,
  exchangeState: string,
  prdtNames: string,
  prdtList: any[]
}

export default function UserExchangeModal({ isOpen, setIsOpen, exchangeState, prdtNames, prdtList }: Props) {
  const handleExchange = () => {
    if (prdtList.length) {
      if (prdtList[0].PrdtView === '03') {
        setIsOpen(false)
        Taro.switchTab({
          url: '/pages/Listen/index'
        })
      } else {
        if (prdtList[0].PrdtType === '03') {
          setIsOpen(false)
          Taro.navigateTo({
            url: '/pages/ListenDetail/index?prdtId=' + prdtList[0].PrdtId
          })
        } else if (prdtList[0].PrdtType === '05') {
          setIsOpen(false)
          Taro.navigateTo({
            url: '/pages/CollectionDetail/index?id=' + prdtList[0].PrdtId
          })
        }
      }
    } else {
      setIsOpen(false)
    }
  }

  if(!isOpen){
    return null
  }

  return (
    <>
      <View
        className='exchange_sucess_mask'
        onClick={() => setIsOpen(false)}
      ></View>
      <View className='exchangee_sucess_modal'>
        <View className='exchange_header'>
          <View className='exchange_title'>兑换{exchangeState === '200' ? '成功' : '失败'}</View>
          <View
            className='exchange_close'
            onClick={() => setIsOpen(false)}
          ></View>
        </View>

        <View className='exchange_content'>
          <Text className='exchange_suc'>{
            exchangeState === '207' ?
              '该兑换码/二维码已被兑换，请核对后再来兑换' :
              exchangeState === '205' ?
                '该兑换码/二维码有误，请核对后再来兑换' :
                exchangeState === '206' ?
                  '该兑换码/二维码已过期，请核对后再来兑换' :
                  exchangeState === '217' ?
                    '该兑换码/二维码你已兑换过，兑换的商品为：' :
                    '兑换商品：'
          }</Text>
          {prdtNames !== '' && <Text className='exchange_prod_name'>{prdtNames}</Text>}
          {/* <Text className='exchange_prod_name'>防守反击双联单控记录卡发撒登记卡理发手打风扇电机开了房防守打法防守打法</Text> */}
        </View>

        <View
          className='exchange_exchange'
          onClick={handleExchange}
        >
          <Text className='exchange_exchange_text'>{prdtList.length ? '立即查看' : '我知道了'}</Text>
        </View>
      </View>
    </>
  )
}
