import { View, Text } from '@tarojs/components'
import { useState } from 'react';
import Taro from '@tarojs/taro';
import './index.less'


export default function GoToStoreModal({ visible, onClose, type, mallLink = 'pages/home/dashboard/index', setmallLink}) {

  //管理关闭动画状态
  const [isAnimationOpen, setisAnimationOpen] = useState(false)

  if(!visible){
    return null
  }

  const handleOverlayClick = (event: any) => {
    // 点击蒙层时关闭弹窗
    setisAnimationOpen(true)
    setTimeout(() =>{
      setisAnimationOpen(false)
      onClose();
    }, 0)
  };

  const handleNavigateToMiniProgram = () => {
    Taro.navigateToMiniProgram({
      appId: 'wxbd3d383851fea776',
      path: mallLink || '',
      success: (res) => {
        console.log('打开成功=>',res)
      },
      fail: (res) => {
        console.log('打开失败=>',res)
      }
    })
    setmallLink('')

    handleOverlayClick(null)
  }

  return (
    <>
      <View
        className='store_overlay'
        onClick={handleOverlayClick}
        style={
          !isAnimationOpen ? { opacity: 1, transition: 'opacity 1s ease-in-out' }
          : { opacity: 0 }
        }
      />
      <View
        className='store_modal'
        style={
          !isAnimationOpen ? { opacity: 1, transition: 'opacity 1s ease-in-out' }
          : { opacity: 0 }
        }
      >
        <View className='store_modal_close' onClick={handleOverlayClick}></View>
        <View className='store_modal_title'>订阅绘本</View>
        <Text className='store_modal_context'>
          {type === 0 ? '您还没有订阅，请前往商城购买' : '更多绘本请前往商城选购'}
        </Text>
        <View
          className='store_modal_container'
          onClick={handleNavigateToMiniProgram}
        >
          <View
            className='store_modal_btn'
          >
            去选购
          </View>
        </View>
      </View>
    </>

  )
}
