import { View, Text, Progress, Image } from '@tarojs/components'
import Taro, { useDidShow, useLoad, useShareAppMessage, useShareTimeline } from '@tarojs/taro'
import React, { useEffect, useState } from 'react'
import './index.less'


export default function AudioInterface() {

  useShareAppMessage((res) => {
    if (res.from === 'button') {
      console.log(res.target);
    }
    return {
      title: '五色花',
      path: '/pages/Home/index'
    }
  })

  useShareTimeline(() => {
    return {
      title: '五色花',
      path: '/pages/Home/index'
    }
  })

  const [testMusic, settestMusic] = useState('http://music.163.com/song/media/outer/url?id=447925558.mp3')

  const [MusicDesc, setMusicDesc] = useState<any>({})

  const [currentTime, setcurrentTime] = useState(0)

  const [durantionTime, setdurantionTime] = useState(230)

  const [isPlay, setisPlay] = useState(false)

  const formatSecondsToTime = (seconds: number) => {
    // 将秒数转换为整数秒和毫秒
    const totalSeconds = Math.floor(seconds);

    // 分钟数
    const minutes = Math.floor(totalSeconds / 60);
    // 剩余秒数
    const remainingSeconds = totalSeconds % 60;

    // 补零操作
    const formattedMinutes = minutes.toString().padStart(2, '0');
    const formattedSeconds = remainingSeconds.toString().padStart(2, '0');

    return `${formattedMinutes}:${formattedSeconds}`;
  }

  useLoad((query) => {
    console.log('query=>', query.id)
    if(Taro.getStorageSync('UserToken')){
      Taro.request({
        url: 'https://interapi.jm-kid.com/api/product/resource',
        method: 'POST',
        header: {
          authorization: `bearer ${Taro.getStorageSync('UserToken')}`
        },
        data: {
          timestamp: Date.now(),
          prdt_id: query.id,
          res_type: '03',
        },
        success: (res) => {
          console.log('产品资源获取成功=>', res.data)
          setMusicDesc(res.data.data.Product)
          setdurantionTime(res.data.data.StoryResource[0].ResDuration)
          settestMusic(res.data.data.StoryResource[0].ResVpath)
          
          // Taro.request({
          //   method: 'POST',
          //   url: 'https://api.jimeikid.com/jiyoumei/system/admin/employee/login',
          //   data: {
          //     "password": "WxBmGKupbl30+v4hfQC8aQ==",
          //     "userName": "VqwgIY4g7s9DanyyqsKP4g==",
          //   },
          //   success: (token_res) => {
          //     if(res.data.data.StoryResource.length){
          //       Taro.request({
          //         method: 'GET',
          //         url: 'https://api.jimeikid.com/jiyoumei/product/app/message/send/history/getPlayInfo',
          //         header: {
          //           authorization: token_res.data.data.token
          //         },
          //         data: {
          //           token: res.data.data.StoryResource[0].ResPwd,
          //           videoId: res.data.data.StoryResource[0].ResVcode,
          //         },
          //         success: function (rres) {
          //           console.log('视频资源请求成功=>', rres)
          //           setdurantionTime(rres.data.data.body.playInfoList.playInfo[0].duration)
          //           settestMusic(rres.data.data.body.playInfoList.playInfo[0].playURL)
          //         }
          //       })
          //     }
          //   },
          // })
        },
        fail: (err) => {
          console.log('产品资源获取失败=>', err)
        }
      })
    }else{
      Taro.request({
        url: 'https://interapi.jm-kid.com/api/product/resource',
        method: 'POST',
        data: {
          timestamp: Date.now(),
          prdt_id: query.id,
          res_type: '03',
        },
        success: (res) => {
          console.log('产品资源获取成功=>', res.data)
          setMusicDesc(res.data.data.Product)
          setdurantionTime(res.data.data.StoryResource[0].ResDuration)
          settestMusic(res.data.data.StoryResource[0].ResVpath)
          
          // Taro.request({
          //   method: 'POST',
          //   url: 'https://api.jimeikid.com/jiyoumei/system/admin/employee/login',
          //   data: {
          //     "password": "WxBmGKupbl30+v4hfQC8aQ==",
          //     "userName": "VqwgIY4g7s9DanyyqsKP4g==",
          //   },
          //   success: (token_res) => {
          //     if(res.data.data.StoryResource.length){
          //       Taro.request({
          //         method: 'GET',
          //         url: 'https://api.jimeikid.com/jiyoumei/product/app/message/send/history/getPlayInfo',
          //         header: {
          //           authorization: token_res.data.data.token
          //         },
          //         data: {
          //           token: res.data.data.StoryResource[0].ResPwd,
          //           videoId: res.data.data.StoryResource[0].ResVcode,
          //         },
          //         success: function (rres) {
          //           console.log('视频资源请求成功=>', rres)
          //           setdurantionTime(rres.data.data.body.playInfoList.playInfo[0].duration)
          //           settestMusic(rres.data.data.body.playInfoList.playInfo[0].playURL)
          //         }
          //       })
          //     }
          //   },
          // })
        },
        fail: (err) => {
          console.log('产品资源获取失败=>', err)
        }
      })
    }
  })

  useEffect(()=>{

    if(currentTime === durantionTime - 1){
      setcurrentTime(0)
    }

    const audioContext = Taro.createInnerAudioContext()
    audioContext.src = testMusic
    if(isPlay){
      if(currentTime !== 0){
        audioContext.seek(currentTime)
      }
      audioContext.play()
    }else{
      audioContext.pause()
    }

    audioContext.onPlay(() => {
      setisPlay(true)
    })
    audioContext.onPause(() => {
      setcurrentTime(audioContext.currentTime)
      setisPlay(false)
    })
    audioContext.onTimeUpdate(() => {
      setcurrentTime(audioContext.currentTime)
    })
    audioContext.onError((res) => {
      console.log('error', res)
    })
    return () => {
      audioContext.destroy()
    }
  }, [isPlay])

  return (
    <View className='audioItfc_bg'>
      <View 
        className='audio_disc'
        style={isPlay ? {animation: 'spin 10s linear infinite', backgroundImage: `url(${MusicDesc.PrdtCover})`} : {backgroundImage: `url(${MusicDesc.PrdtCover})`}}
      >
        <View className='audio_disc_bearing'></View>
      </View>
      
      <View className='audio_progress_bar'>
        <Text className='audio_title'>{MusicDesc.PrdtTitle}</Text>
        {/* <Text className='audio_discription'>{MusicDesc.PrdtDescription}</Text>
        <View className='audio_tips'>
          {
            MusicDesc && MusicDesc.PrdtKeys && MusicDesc.PrdtKeys.map((item: any, index: number) => (
              <View 
                className='audio_tip'
                key={index}
              >
                <Text className='audio_tip_text'>{item}</Text>
              </View>
            ))
          }
        </View> */}
        <Progress 
          className='audio_progress'
          percent={currentTime/durantionTime*100}  
          activeColor='#3BA366'
          strokeWidth={2}
        ></Progress>
        <View className='audio_progress_time_bar'>
          <View 
            className='audio_progress_time' 
            style={{marginRight: 'auto'}}
          >
            {formatSecondsToTime(currentTime)}
          </View>
          <View 
            className='audio_progress_time' 
            style={{marginLeft: 'auto'}}
          >
            {formatSecondsToTime(durantionTime)}
          </View>
        </View>
        <View className='audio_operate'>
          <Image 
            className='audio_operate_btn0'
            style={{marginLeft: 'auto', marginRight: '0'}}
            src='https://oss.jm-kid.com/wx_5colorflower/prevMusic.png'
          ></Image>
          <Image 
            className='audio_operate_btn1'
            src={isPlay ? 'https://oss.jm-kid.com/wx_5colorflower/pauseMusic.png' : 'https://oss.jm-kid.com/wx_5colorflower/playMusic.png'}
            onClick={() => setisPlay(!isPlay)}
          ></Image>
          <Image 
            className='audio_operate_btn0'
            style={{marginRight: 'auto', marginLeft: '0'}}
            src='https://oss.jm-kid.com/wx_5colorflower/nextMusic.png'
          ></Image>
        </View>
        
      </View>
      
    </View>
  )
}
