import { View, Image, Text, ScrollView, Swiper, SwiperItem } from '@tarojs/components'
import Taro, { useDidShow, useDidHide, useLoad, useShareAppMessage, useShareTimeline } from '@tarojs/taro'
import { useEffect, useState } from 'react'
import './index.less'
import GetPhoneNumber from '../../components/getPhoneModal'
import GoToStoreModal from '../../components/goToStoreModal'
import UserExchangeSuccessModal from '../../components/UserExchangeSuccessModal'
import Gift from '../../components/gift'

interface FreeItemProps {
  Child: any[],
  ChildNum: number,
  MallLink: string,
  PrdtCover: string,
  PrdtId: string,
  PrdtOrder: number,
  PrdtSubtitle: string,
  PrdtTitle: string,
  IsSubscribed: number,
}

export default function Home() {

  useShareAppMessage((res) => {
    if (res.from === 'button') {
      console.log(res.target);
    }
    return {
      title: '五色花',
      path: '/pages/Home/index'
    }
  })

  useShareTimeline(() => {
    return {
      title: '五色花',
      path: '/pages/Home/index'
    }
  })

  const [isToStoreOpen, setisToStoreOpen] = useState(false)

  useLoad((query) => {
    console.log(query.scene)
    if (query.scene) {
      console.log('不知道在判断什么玩意儿')
      const userCode = decodeURIComponent(query.scene).slice(-8)
      if(!Taro.getStorageSync('UserToken')){
        setisLoginOpen(true)
        setuserScene(userCode)
      }else{
        Taro.request({
          url: 'https://interapi.jm-kid.com/api/product/exchange',
          method: 'POST',
          header: {
            authorization: `bearer ${Taro.getStorageSync('UserToken')}`
          },
          data: {
            timestamp: Date.now(),
            change_code: userCode
          },
          success: (s_res: any) => {
            const { state, data } = s_res.data
            setExchangeState(state)
            // 有返回商品名称，则显示；否则只显示提示语
            if(data && data.Subscribed){
              const list = data.Subscribed
              setPrdtNames(list.map((e: any) => e.PrdtTitle).join('；'))
              setPrdtList(list)
            }
            setisUserExchangeSuccessModalOpen(true)
          },
          fail: (err: any) => {
            console.log('兑换失败=>', err)
          }
        })
      }

    }

  })

  //判断是否登录
  const [isGetUsePhone, setisGetUsePhone] = useState(false) //false

  //管理登录弹窗
  const [isLoginOpen, setisLoginOpen] = useState(false)

  const [userScene, setuserScene] = useState<any>(null)

  //首页banner图集
  const [bannerList, setbannerList] = useState([])

  //免费绘本集
  const [freeBook, setfreeBook] = useState<FreeItemProps[]>()

  //爆品集
  const [hotBook, sethotBook] = useState([])

  //管理跳转页面路径
  const [prdtMallLink, setprdtMallLink] = useState('')

  // 兑换成功弹窗
  const [isUserExchangeSuccessModalOpen, setisUserExchangeSuccessModalOpen] = useState(false)

  // 兑换接口返回的state
  const [exchangeState, setExchangeState] = useState('')

  // 兑换成功的商品名称字符串
  const [prdtNames, setPrdtNames] = useState('')

  // 兑换成功的商品名称数组
  const [prdtList, setPrdtList] = useState([])

  //点击免费试读跳转
  const handleNavigateToFreeRead = (id: number) => {
    console.log('点击免费试读跳转', id)
    Taro.navigateTo({
      url: '/pages/SingleDetail/index?id=' + id
    })
  }

  useDidShow(() => {
    Taro.request({
      url: 'https://interapi.jm-kid.com/api/app/operation',
      method: 'POST',
      data: {
        timestamp: Date.now(),
        type: 'free_books'
      },
      success: (res:any) => {
        console.log('免费绘本获取成功=>',res)
        setfreeBook(res.data.data)
      }
    })

    if(Taro.getStorageSync('UserToken')){
      Taro.request({
        url: 'https://interapi.jm-kid.com/api/app/operation',
        method: 'POST',
        header: {
          authorization: `bearer ${Taro.getStorageSync('UserToken')}`
        },
        data: {
          timestamp: Date.now(),
          type: 'hot_books'
        },
        success: (res:any) => {
          console.log('爆品绘本获取成功=>',res)
          sethotBook(res.data.data)
        }
      })

      Taro.request({
        url: 'https://interapi.jm-kid.com/api/app/index',
        method: 'POST',
        header: {
          authorization: `bearer ${Taro.getStorageSync('UserToken')}`
        },
        data: {
          timestamp: Date.now(),
        },
        success: (res:any) => {
          console.log('banner获取成功=>',res)
          setbannerList(res.data.data.banner)
        }
      })
    }else{
      Taro.request({
        url: 'https://interapi.jm-kid.com/api/app/operation',
        method: 'POST',
        data: {
          timestamp: Date.now(),
          type: 'hot_books'
        },
        success: (res:any) => {
          console.log('爆品绘本获取成功=>',res)
          sethotBook(res.data.data)
        }
      })

      Taro.request({
        url: 'https://interapi.jm-kid.com/api/app/index',
        method: 'POST',
        data: {
          timestamp: Date.now(),
        },
        success: (res:any) => {
          console.log('banner获取成功=>',res)
          setbannerList(res.data.data.banner)
        }
      })
    }

  })

  useDidHide(() => {
    setisGetUsePhone(false)
    setisLoginOpen(false)
  })

  //用户登录后重新请求爆品
  useEffect(() => {
    if(isGetUsePhone){
      Taro.request({
        url: 'https://interapi.jm-kid.com/api/app/operation',
        method: 'POST',
        header: {
          authorization: `bearer ${Taro.getStorageSync('UserToken')}`
        },
        data: {
          timestamp: Date.now(),
          type: 'hot_books'
        },
        success: (res:any) => {
          console.log('爆品绘本获取成功=>',res)
          sethotBook(res.data.data)
        }
      })

      Taro.request({
        url: 'https://interapi.jm-kid.com/api/app/index',
        method: 'POST',
        header: {
          authorization: `bearer ${Taro.getStorageSync('UserToken')}`
        },
        data: {
          timestamp: Date.now(),
        },
        success: (res:any) => {
          console.log('banner获取成功=>',res)
          setbannerList(res.data.data.banner)
        }
      })
    }
  }, [isGetUsePhone])

			// 消息推送授权
	const publicNotice = (callback) => {
    Taro.requestSubscribeMessage({
      tmplIds: ['F5kG9ryTuf3U09liOVIqqZDDEwNwiuWbLPPdoVpKPWI', 'cnMggWGwr0_cVw7Hf_fg3u74EDJdA0b4e56Ioy-Vr_Q'],
      success() {
        callback && callback()
      },
      fail() {
        callback && callback()
      },
    })
  }

  const toDetail = (item: FreeItemProps, child: FreeItemProps | undefined) => {
    const { IsSubscribed, PrdtId, MallLink } = item
    if (IsSubscribed === 0) {
      //提醒用户登录
      publicNotice(() => setisLoginOpen(true))
    }else if(!child){
      Taro.navigateTo({
        url: `/pages/CollectionDetail/index?id=${PrdtId}`
      })
    }else if (IsSubscribed === -1 || IsSubscribed === 2) {
      //未订阅，跳转商城
      setprdtMallLink(MallLink || '')
      setisToStoreOpen(true)
    }else if(IsSubscribed === 1){
      //已订阅，跳转详情页
      Taro.navigateTo({
        url: `/pages/SingleDetail/index?id=${child.PrdtId}`
      })
    }
  }

  const handleBannerClick = (item: any) => {
    if(item.is_subscribed === 0){
      //提醒用户登录
      publicNotice(() => setisLoginOpen(true))
    } else {
      //已订阅，跳转详情页
      publicNotice(() => {
        Taro.navigateTo({
          url: '/pages/Share/index'
        })
      })
    }
  }

  return (
    <ScrollView
      className='home_bg'
      scrollY
      scrollWithAnimation
    >
      <View className='home_swiper'>
        <Swiper
          className='swiper_container'
          circular
          indicatorDots
          indicatorColor='#999'
          indicatorActiveColor='#333'
          autoplay
        >
          {
            bannerList.map((item: any, index: number) => (
              <SwiperItem
                className='swiper_item'
                key={index}
                onClick={()=>handleBannerClick(item)}
              >
                <Image className='swiper_item_img' src={item.url}></Image>
              </SwiperItem>
            ))
          }

        </Swiper>
      </View>
      <View className='home_capsule'></View>
      <View className='home_single_container'>
        {
          //@ts-ignore
          freeBook && freeBook[0].Child.map((item: any, index: number) => (
            <View
              className='free_item'
              key={index}
            >
              <View className='relative_container'>
                <View className='free_item_label'>
                  <Text className='free_item_label_text'>免费绘本</Text>
                </View>
              </View>
              <Image
                src={item.PrdtCover}
                className='free_item_cover'
                onClick={()=>handleNavigateToFreeRead(item.PrdtId)}
                lazyLoad
              />
              <Text
                className='free_item_title'
              >
                {item.PrdtTitle}
              </Text>
            </View>
          ))
        }
      </View>
      <View
        className='home_single_checkMore_container'
        onClick={()=> {
          if(freeBook)
            Taro.navigateTo({
              url: '/pages/CollectionDetail/index?id=' + freeBook[0].PrdtId
            })
        }}
      >
        <View className='home_single_checkMore'>
          <Text
            className='home_single_checkMore_text'
          >
            查看更多免费绘本
          </Text>
        </View>
      </View>
      <View className='home_hot_container'>
        <View className='home_hot_title'>
          <Text className='home_hot_title_text'>爆款产品</Text>
        </View>
        {
          hotBook.map((item: any, index: number) => (
            <View
              className='home_hot_item'
              key={index}
            >
              <View className='hot_info'
                onClick={()=>toDetail(item)}
              >
                <Image
                  className='hot_info_cover'
                  src={item.PrdtCover}
                  mode='scaleToFill'
                ></Image>
                <View className='hot_info_context'>
                  <View className='hot_info_title'>{item.PrdtTitle}</View>
                  <View className='hot_info_intro'>{item.PrdtSubtitle}</View>
                  <View className='hot_info_btn'>
                    <View className='hot_info_btn_text'>查看更多</View>
                  </View>
                </View>
              </View>
              <View className='hot_details'>
                {
                  item.Child.map((childItem: any, Childindex: number) => (
                    <View
                      className='hot_details_item'
                      key={Childindex}
                      onClick={()=>toDetail(item, childItem)}
                    >
                      <Image
                        className='hot_details_item_cover'
                        src={childItem.PrdtCover}
                        lazyLoad
                      ></Image>
                      <View className='hot_details_item_title'>{childItem.PrdtTitle}</View>
                    </View>
                  ))
                }
              </View>
            </View>
          ))
        }

      </View>

      <Gift />

      <UserExchangeSuccessModal exchangeState={exchangeState} prdtList={prdtList} prdtNames={prdtNames} isOpen={isUserExchangeSuccessModalOpen} setIsOpen={setisUserExchangeSuccessModalOpen}></UserExchangeSuccessModal>

      <GetPhoneNumber
        onClose={setisGetUsePhone}
        scene={userScene}
        modalVisible={isLoginOpen}
        onModalClose={() => setisLoginOpen(false)}
      ></GetPhoneNumber>

      <GoToStoreModal
        visible={isToStoreOpen}
        onClose={() => setisToStoreOpen(false)}
        type={0}
        mallLink={prdtMallLink}
        setmallLink={setprdtMallLink}
      ></GoToStoreModal>
    </ScrollView>
  )
}
