import { Swiper, SwiperItem, View, Image, Text } from '@tarojs/components'
import React, { useEffect, useState } from 'react'
import Taro, { useDidShow, useDidHide } from '@tarojs/taro'
import './index.less'
import GetPhoneNumber from '../../components/getPhoneModal'
import Gift from '../../components/gift'

// const areaList = [
//   {
//     index: 0,
//     name: '免费专区',
//     child: [
//       {
//         index: 0,
//         icon: '',
//         title: 'daaswcaw',
//       },
//       {
//         index: 1,
//         icon: '',
//         title: 'dawawd',
//       },
//       {
//         index: 2,
//         icon: '',
//         title: 'dawdawd',
//       },
//     ]
//   },
//   {
//     index: 1,
//     name: '哄睡故事',
//     child: [
//       {
//         index: 0,
//         icon: '',
//         title: 'tgdwcaw',
//       },
//       {
//         index: 1,
//         icon: '',
//         title: 'dfdd',
//       },
//       {
//         index: 2,
//         icon: '',
//         title: 'vsawd',
//       },
//     ]
//   },
//   {
//     index: 2,
//     name: '牛魔王',
//     child: [
//       {
//         index: 0,
//         icon: '',
//         title: 'dewqeqwcaw',
//       },
//       {
//         index: 1,
//         icon: '',
//         title: 'eqweqwwd',
//       },
//       {
//         index: 2,
//         icon: '',
//         title: 'fcwwdawd',
//       },
//     ]
//   },
// ]

export default function Listen() {

  //首页banner图集
  const [bannerList, setbannerList] = useState([])

  const [typeList, settypeList] = useState([])

  const [areaList, setareaList] = useState([])

  //判断是否登录
  const [isGetUsePhone, setisGetUsePhone] = useState(false) //false

  //管理登录弹窗
  const [isLoginOpen, setisLoginOpen] = useState(false)

  const [memberInfo, setMemberInfo] = useState({})

  useDidShow(() => {
    if(Taro.getStorageSync('UserToken')){
      Taro.request({
        method: 'POST',
        url: 'https://interapi.jm-kid.com/api/audio/index',
        header: {
          authorization: `bearer ${Taro.getStorageSync('UserToken')}`
        },
        data: {
          timestamp: Date.now(),
        },
        success: (res)=> {
          console.log('熏听首页banner及金刚区接口请求成功' ,res.data)
          setbannerList(res.data.data.banner)
          settypeList(res.data.data.head)
        }
      })

      Taro.request({
        method: 'POST',
        url: 'https://interapi.jm-kid.com/api/audio/operation',
        header: {
          authorization: `bearer ${Taro.getStorageSync('UserToken')}`
        },
        data: {
          timestamp: Date.now(),
        },
        success: (res)=> {
          console.log('熏听首页运营数据接口请求成功' ,res.data)
          setareaList(res.data.data.show)
        }
      })

      // 获取会员跳转链接
      Taro.request({
        url: 'https://interapi.jm-kid.com/api/member/data',
        method: 'POST',
        header: {
          authorization: `bearer ${Taro.getStorageSync('UserToken')}`
        },
        data: {
          timestamp: Date.now(),
          member_type: 'audio'
        },
        success: (res: any) => {
          if(res.data.state === 200){
            setMemberInfo(res.data.data.main)
          }
        },
      })
    }else{
      Taro.request({
        method: 'POST',
        url: 'https://interapi.jm-kid.com/api/audio/index',
        data: {
          timestamp: Date.now(),
        },
        success: (res)=> {
          console.log('熏听首页banner及金刚区接口请求成功' ,res.data)
          setbannerList(res.data.data.banner)
          settypeList(res.data.data.head)
        }
      })

      Taro.request({
        method: 'POST',
        url: 'https://interapi.jm-kid.com/api/audio/operation',
        data: {
          timestamp: Date.now(),
        },
        success: (res)=> {
          console.log('熏听首页运营数据接口请求成功' ,res.data)
          setareaList(res.data.data.show)
        }
      })
    }
  })

  useDidHide(() => {
    setisGetUsePhone(false)
    setisLoginOpen(false)
  })

  useEffect(() => {
    if(isGetUsePhone){
      Taro.request({
        method: 'POST',
        url: 'https://interapi.jm-kid.com/api/audio/index',
        header: {
          authorization: `bearer ${Taro.getStorageSync('UserToken')}`
        },
        data: {
          timestamp: Date.now(),
        },
        success: (res)=> {
          console.log('熏听首页banner及金刚区接口请求成功' ,res.data)
          setbannerList(res.data.data.banner)
          settypeList(res.data.data.head)
        }
      })

      Taro.request({
        method: 'POST',
        url: 'https://interapi.jm-kid.com/api/audio/operation',
        header: {
          authorization: `bearer ${Taro.getStorageSync('UserToken')}`
        },
        data: {
          timestamp: Date.now(),
        },
        success: (res)=> {
          console.log('熏听首页运营数据接口请求成功' ,res.data)
          setareaList(res.data.data.show)
        }
      })
    }
  }, [isGetUsePhone])

  const handleTypeClick = (index: string) => {
    if(index === "03"){
      Taro.navigateTo({
        url: '/pages/ListenType/MainType/index'
      })
    }else{
      Taro.navigateTo({
        url: '/pages/ListenType/SingleType/index?index=' + index
      })
    }
  }

  const handleAreaClick = (index: number) => {
    Taro.navigateTo({
      url: '/pages/ListenRegion/index?index=' + index
    })
  }
  const handleDetail = (prdtId: number) => {
    Taro.navigateTo({
      url: '/pages/ListenDetail/index?prdtId=' + prdtId
    })
  }

	// 消息推送授权
	const publicNotice = (callback) => {
    Taro.requestSubscribeMessage({
      tmplIds: ['F5kG9ryTuf3U09liOVIqqZDDEwNwiuWbLPPdoVpKPWI', 'cnMggWGwr0_cVw7Hf_fg3u74EDJdA0b4e56Ioy-Vr_Q'],
      success() {
        callback && callback()
      },
      fail() {
        callback && callback()
      },
    })
  }

  const handleBannerClick = (item: any, index: number) => {
    if (!index) {
      if(!Taro.getStorageSync('UserToken')){
        //提醒用户登录
        publicNotice(() => setisLoginOpen(true))
      } else {
        // 跳转到熏听会员
        Taro.navigateToMiniProgram({
          appId: 'wxbd3d383851fea776',
          path: memberInfo?.MallLink || '',
          success: (res) => {
            console.log('打开成功=>',res)
          },
          fail: (res) => {
            console.log('打开失败=>',res)
          }
        })
      }
    }
  }

  return (
    <View className='listen_bg'>
      <View
        className='listen_search'
        onClick={()=>{
          Taro.navigateTo({
            url: '/pages/ListenSearch/index'
          })
        }}
      >
        <View className='listen_search_icon'></View>
        <View className='listen_search_input'>请输入专辑名称</View>
      </View>

      <View className='listen_banner'>
        <Swiper
          className='swiper_container'
          circular
          indicatorDots
          indicatorColor='#999'
          indicatorActiveColor='#333'
          autoplay
        >
          {
            bannerList.map((item: any, index: number) => (
              <SwiperItem
                className='swiper_item'
                key={index}
                onClick={()=>handleBannerClick(item, index)}
              >
                <Image className='swiper_item_img' src={item.url} mode='scaleToFill'></Image>
              </SwiperItem>
            ))
          }
        </Swiper>
      </View>

      <View className='listen_type'>
        {
          typeList.map((item: any, index: number) => (
            <View
              key={index}
              className='item'
              onClick={() => {handleTypeClick(item.site_class)}}
            >
              <Image
                className='icon'
                src={item.url}
              ></Image>
              <View className='name'>{item.title}</View>
            </View>
          ))
        }
      </View>

      <View className='listen_area'>
        {
          areaList.map((item: any, index: number) => (
            <View
              key={index}
              className='item'
            >
              <View className='header'
                onClick={()=>handleAreaClick(item.site_id)}
              >
                <View className='title'>{item.title}</View>
                <View className='more'>更多</View>
                <View className='more_icon' ></View>
              </View>
              <View className='selection'>
                {
                  item.products.map((child: any, c_index: number) => (
                    <View
                      key={c_index}
                      className='item'
                      onClick={()=>handleDetail(child.PrdtId)}
                    >
                      {
                        item.is_free === 1 &&
                        <View className='relative_container'>
                        <View className='free_item_label'>
                          <Text className='free_item_label_text'>免费专辑</Text>
                        </View>
                      </View>
                      }

                      <Image
                        className='icon'
                        src={child.PrdtCover}
                        lazyLoad
                      ></Image>
                      <View className='title'>{child.PrdtTitle}</View>
                    </View>
                  ))
                }
              </View>
            </View>
          ))
        }
      </View>

      <Gift />

      <GetPhoneNumber
        onClose={setisGetUsePhone}
        modalVisible={isLoginOpen}
        onModalClose={() => setisLoginOpen(false)}
      ></GetPhoneNumber>
    </View>
  )
}
