import { ScrollView, View, Image } from '@tarojs/components'
import React, { useState } from 'react'
import Taro, { useLoad } from '@tarojs/taro'
import { AtAccordion } from 'taro-ui'
import './index.less'

export default function ListenRegion() {

  const [regionList, setregionList] = useState<any>([])

  const [ifMB, setifMB] = useState(false)

  const [isAcOpen, setisAcOpen] = useState(
    regionList.reduce((acc, option) => ({ ...acc, [option.title]: true }), {})
  )

  const [isAcItem, setisAcItem] = useState<any[]>(
    regionList.map(option => option.id)
  )

  useLoad((query)=>{
    console.log('query=>', query.index)

    if(Taro.getStorageSync('UserToken')){
      Taro.request({
        method: 'POST',
        url: 'https://interapi.jm-kid.com/api/audio/show/product',
        header: {
          authorization: `bearer ${Taro.getStorageSync('UserToken')}`
        },
        data: {
          timestamp: Date.now(),
          site_id: query.index
        },
        success: (res)=> {
          console.log('region接口请求成功' ,res.data)
          if(res.data.data.show.site_id === 334){
            setifMB(true)
            setregionList(res.data.data.show.grouped_products)
          }else{
            setregionList(res.data.data.show.products)
          }
          setpageTitle(res.data.data.show.title)

          Taro.setNavigationBarTitle({
            title: res.data.data.show.title
          })

          const initialStates = res.data.data.show.grouped_products.reduce((acc, option) => ({ ...acc, [option.title]: true }), {});
          console.log('initialStates', initialStates)
          setisAcOpen(initialStates)
          setisAcItem(res.data.data.show.grouped_products.map(option => option.id))

          console.log('isAcOpen', isAcOpen)
          console.log('isAcItem', isAcItem)
        }
      })
    }else{
      Taro.request({
        method: 'POST',
        url: 'https://interapi.jm-kid.com/api/audio/show/product',
        data: {
          timestamp: Date.now(),
          site_id: query.index
        },
        success: (res)=> {
          console.log('region接口请求成功' ,res.data)
          if(res.data.data.show.site_id === 334){
            setifMB(true)
            setregionList(res.data.data.show.grouped_products)
          }else{
            setregionList(res.data.data.show.products)
          }
          setpageTitle(res.data.data.show.title)

          Taro.setNavigationBarTitle({
            title: res.data.data.show.title
          })
        }
      })
    }
  })

  const [pageTitle, setpageTitle] = useState('')

  const handleBack = () => {
    Taro.navigateBack()
  }

  const handleDetail = (prdtId: number) => {
    Taro.navigateTo({
      url: '/pages/ListenDetail/index?prdtId=' + prdtId
    })
  }

  return (
    <View className='listenRegion_bg'>
      <View className='container'>
        {
          !ifMB && regionList.map((item, index) => (
            <View
              key={index}
              className='item'
              onClick={()=>handleDetail(item.PrdtId)}
            >
              <Image
                className='icon'
                src={item.PrdtCover}
              ></Image>
              <View className='title'>{item.PrdtTitle}</View>
            </View>
          ))
        }
      </View>
      <View
        className='acContainer'
      >
        {
          ifMB && regionList.map((item: any, index: number) => (
            <AtAccordion
              key={index}
              open={isAcOpen[item.title]}
              title={item.title}
              onClick={() => {
                // 更新选项状态
                setisAcOpen(prevStates => ({
                  ...prevStates,
                  [item.title]: !prevStates[item.title],
                }));

                // 更新已选选项
                if (isAcItem.includes(index)) {
                  setisAcItem(isAcItem.filter(i => i !== index));
                } else {
                  setisAcItem([...isAcItem, index]);
                }

                console.log('isAcOpen', isAcOpen)
                console.log('isAcItem', isAcItem)
              }}
              style={{
                display: 'flex',
                flexDirection: 'row',
              }}
            >
              <View className='acItem'>
                {
                  item.list.map((acitem, acindex) => (
                    <View
                      key={acindex}
                      className='item'
                      onClick={()=>handleDetail(acitem.prdt_id)}
                    >
                      <Image
                        className='icon'
                        src={acitem.prdt_cover}
                      ></Image>
                      <View className='title'>{acitem.prdt_title}</View>
                    </View>
                  ))
                }
              </View>

            </AtAccordion>
          ))
        }
      </View>
    </View>
  )
}
