import { ScrollView, View, Image } from '@tarojs/components'
import React, { useEffect, useState } from 'react'
import Taro, { useLoad } from '@tarojs/taro'
import './index.less'


// const typeList = [
//   {
//     index: 0,
//     name: '全部',
//   },
//   {
//     index: 1,
//     name: '听儿歌',
//   },
//   {
//     index: 2,
//     name: '听故事',
//   },
//   {
//     index: 3,
//     name: '听英语',
//   },
//   {
//     index: 4,
//     name: '听国学',
//   },
// ]

// const typetypeList = [
//   {
//     index: 0,
//     name: 'dqwsq'
//   },
//   {
//     index: 1,
//     name: 'dqwsq'
//   },
//   {
//     index: 2,
//     name: 'dqwsq'
//   },
//   {
//     index: 3,
//     name: 'dqwsq'
//   },
//   {
//     index: 4,
//     name: 'dqwsq'
//   },
//   {
//     index: 5,
//     name: 'dqwsq'
//   },
//   {
//     index: 6,
//     name: 'dqwsq'
//   },
//   {
//     index: 7,
//     name: 'dqwsq'
//   },
//   {
//     index: 8,
//     name: 'dqwsq'
//   },
//   {
//     index: 9,
//     name: 'dqwsq'
//   },
//   {
//     index: 10,
//     name: 'dqwsq'
//   },
//   {
//     index: 11,
//     name: 'dqwsq'
//   },
//   {
//     index: 12,
//     name: 'dqwsq'
//   },
//   {
//     index: 13,
//     name: 'dqwsq'
//   },
//   {
//     index: 14,
//     name: 'dqwsq'
//   },
//   {
//     index: 15,
//     name: 'dqwsq'
//   },
//   {
//     index: 16,
//     name: 'dqwsq'
//   },
//   {
//     index: 17,
//     name: 'dqwsq'
//   },
//   {
//     index: 18,
//     name: 'dqwsq'
//   },
//   {
//     index: 19,
//     name: 'dqwsq'
//   },
//   {
//     index: 20,
//     name: 'dqwsq'
//   },
//   {
//     index: 21,
//     name: 'dqwsq'
//   },
// ]

export default function MainType() {

  const [chooseType, setchooseType] = useState(0)

  const [choooseTypeType, setchoooseTypeType] = useState<number | string>('')

  const [typeList, settypeList] = useState<any>([])

  const [typeCode, settypeCode] = useState('')

  const [typetypeList, settypetypeList] = useState<any>([])

  useLoad(()=>{
    Taro.request({
      method: 'POST',
      url: 'https://interapi.jm-kid.com/api/audio/category',
      data: {
        timestamp: Date.now(),
      },
      success: (res) => {
        console.log('熏听区两级分类数据请求成功' ,res.data)
        let data = res.data.data.category
        // res.data.data.category[0].children = [
        //   {
        //     class_code: "03",
        //     class_name: "全部",
        //   }
        // ]
        console.log('熏听区两级分类数据处理后的数据', data)
        settypeList(data)
      }
    })
  })

  useEffect(()=> {
    Taro.request({
      method: 'POST',
      url: 'https://interapi.jm-kid.com/api/audio/class/product',
      data: {
        timestamp: Date.now(),
        class_code: typeCode
      },
      success: (res) => {
        console.log('获取金刚区内容列表数据请求成功' ,res.data)
        settypetypeList(res.data.data.products)
      }
    })
  }, [typeCode])

  const handleChooseType = (index: number) => {
    console.log('选择的分类', index)
    setchooseType(index)
    setchoooseTypeType('')
    settypeCode(typeList[index].class_code)
  }

  const handleChooseTypeType = (index: number) => {
    setchoooseTypeType(index)
    settypeCode(typeList[chooseType].children[index].class_code)
  }

  const handleDetail = (prdtId: number) => {
    Taro.navigateTo({
      url: '/pages/ListenDetail/index?prdtId=' + prdtId
    })
  }

  return (
    <View className='main_bg'>
      <ScrollView
        scrollX
        scrollWithAnimation
        className='main_top'
      >
        <View className='top_container'>
          {
            typeList.map((item: any, index: number) => (
              <View
                key={index}
                className='item'
                onClick={() => handleChooseType(index)}
              >
                <View
                  className='title'
                  style={chooseType === index? {color: '#3ba366', fontWeight: '600'} : {}}
                >
                  {item.class_name}
                </View>
              </View>
            ))
          }
        </View>
      </ScrollView>
      <View className='main_context'>
        <View className='type_container'>
          <ScrollView
            className='typelist'
            scrollY
            scrollWithAnimation
          >
              {
                typeList && chooseType !== -1 && typeList[chooseType] && typeList[chooseType].children.map((item: any, index: number) => (
                  <View
                    key={index}
                    className={`item ${choooseTypeType === index ? 'active' : choooseTypeType === index + 1 ? 'active-prev' : choooseTypeType === index - 1 ? 'active-next' : ''}`}
                    onClick={()=>handleChooseTypeType(index)}
                  >{item.class_name}</View>
                ))
              }
          </ScrollView>
        </View>

        <View className='product_container'>
          <ScrollView
            className='product'
            scrollY
            scrollWithAnimation
          >
            <View className='container'>
              {
                typetypeList.map((item: any, index: number) => (
                  <View
                    key={index}
                    className='item'
                    onClick={()=>handleDetail(item.PrdtId)}
                  >
                    <Image
                      className='icon'
                      src={item.PrdtCover}
                      lazyLoad
                    ></Image>
                    <View className='title'>{item.PrdtTitle}</View>
                  </View>
                ))
              }
            </View>
          </ScrollView>
        </View>


      </View>
    </View>
  )
}
