import { Image, Button } from '@tarojs/components'
import Taro, { useShareAppMessage, useShareTimeline, useLoad } from '@tarojs/taro'
import './index.less'

export default function Share() {
  const inviteCode = Taro.getStorageSync('UserInviteCode') // 邀请码

  useShareAppMessage((res) => {
    if (res.from === 'button') {
      console.log(res.target);
    }
    return {
      title: '五色花',
      path: `/pages/Home/index?inviteCode=${inviteCode}`
    }
  })

  useShareTimeline(() => {
    return {
      title: '五色花',
      path: `/pages/Home/index?inviteCode=${inviteCode}`
    }
  })

  useLoad(()=>{
    if(Taro.getStorageSync('UserToken')){
      // 埋点
      Taro.request({
        method: 'POST',
        url: 'https://interapi.jm-kid.com/api/embedpoint',
        header: {
          authorization: `bearer ${Taro.getStorageSync('UserToken')}`
        },
        data: {
          timestamp: Date.now(),
          action_code: '1001001',
          value: 0
        }
      })
    }
  })

  return (
    <Button openType='share' className='share_btn'>
      <Image
        src='https://oss.jm-kid.com/wx_5colorflower/icons/share.svg'
        className='pic'
        mode='aspectFill'
      ></Image>
    </Button>
  )
}
