import { useEffect, useRef, useState } from 'react'
import Taro, { useDidShow, useDidHide, useShareAppMessage, useShareTimeline } from '@tarojs/taro'
import { Image, Input, ScrollView, View, Text } from '@tarojs/components'
import PopupHalfScreen from '../../components/Popup'

import DefaultPage1 from '../../components/defaultPage1'
import GetPhoneNumber from '../../components/getPhoneModal'
import GoToStoreModal from '../../components/goToStoreModal'
import UserExchangeSuccessModal from '../../components/UserExchangeSuccessModal'
import Gift from '../../components/gift'

import './index.less'
import DefaultPage3 from '../../components/defaultPage3'

export default function Subscribe() {

  useShareAppMessage((res) => {
    if (res.from === 'button') {
      console.log(res.target);
    }
    return {
      title: '五色花',
      path: '/pages/Home/index'
    }
  })

  useShareTimeline(() => {
    return {
      title: '五色花',
      path: '/pages/Home/index'
    }
  })

  //单本订阅列表
  const [userSubscribeSingleList, setuserSubscribeSingleList] = useState([])

  //套装订阅列表
  const [userSubscribeCollectionList, setuserSubscribeCollectionList] = useState([])

  //单本免费订阅统计
  const [userSubscribeSingleFreeCount, setuserSubscribeSingleFreeCount] = useState(0)

  //单本付费订阅统计
  const [userSubscribeSinglePaidCount, setuserSubscribeSinglePaidCount] = useState(0)

  //套装免费订阅统计
  const [userSubscribeCollectionFreeCount, setuserSubscribeCollectionFreeCount] = useState(0)

  //套装付费订阅统计
  const [userSubscribeCollectionPaidCount, setuserSubscribeCollectionPaidCount] = useState(0)

  //搜索框内容
  const [searchValue, setsearchValue] = useState('')

  //搜索内容
  const [searchResult, setsearchResult] = useState([])

  //管理登录弹窗
  const [isGetUsePhone, setisGetUsePhone] = useState(false)

  //管理登录弹窗
  const [isLoginOpen, setisLoginOpen] = useState(false)

  const [isFilter, setisFilter] = useState(null)

  useEffect(() => {
    if(isFilter){
      if(isFilter === 'reset'){
        console.log('重置筛选状态', isFilter)
        //查询用户订阅信息
        Taro.request({
          url: 'https://interapi.jm-kid.com/api/product/subscribed',
          method: 'POST',
          header: {
            authorization: 'bearer ' + Taro.getStorageSync('UserToken')
          },
          data: {
            timestamp: Date.now(),
            // filter: ''
          },
          success: (res: any) => {
            console.log('用户订阅信息', res)

            //单本订阅列表
            let singleArr: any = []

            //统计单本免费订阅数量
            let a: number = 0

            //统计套装免费订阅数量
            let b: number = 0

            //统计单本付费订阅数量
            let c: number = 0

            //统计套装付费订阅数量
            let d: number = 0

            for(let item of res.data.data.FreeProducts){

              b++

              for(let sec_item of item.Child){

                if(!singleArr.some((arr_item : any) => arr_item === sec_item)){
                  sec_item.isFree = 1
                  singleArr.push(sec_item)
                  a++
                }
              }
            }

            for(let item of res.data.data.SubscribedProducts){

              d++

              for(let sec_item of item.Child){

                if(!singleArr.some((arr_item : any) => arr_item === sec_item)){
                  sec_item.isFree = 0
                  // sec_item.MallLink = item.MallLink || ''
                  singleArr.push(sec_item)
                  c++
                }
              }
            }

            console.log('单本订阅列表', singleArr)
            setuserSubscribeSingleList(singleArr)
            setuserSubscribeSingleFreeCount(a)
            setuserSubscribeSinglePaidCount(c)
            setuserSubscribeCollectionFreeCount(b)
            setuserSubscribeCollectionPaidCount(d)

            //套装订阅列表
            let collectionArr: any = []
            for(let item of res.data.data.FreeProducts){
              if(!collectionArr.some((arr_item : any) => arr_item === item)){
                item.isFree = 1
                collectionArr.push(item)
              }
            }

            for(let item of res.data.data.SubscribedProducts){
              if(!collectionArr.some((arr_item : any) => arr_item === item)){
                item.isFree = 0
                collectionArr.push(item)
              }
            }

            console.log('套装订阅列表', collectionArr)
            setuserSubscribeCollectionList(collectionArr)
          }
        })
      }else{
        console.log('筛选状态=>', isFilter)
        //查询用户订阅信息
        Taro.request({
          url: 'https://interapi.jm-kid.com/api/product/subscribed',
          method: 'POST',
          header: {
            authorization: 'bearer ' + Taro.getStorageSync('UserToken')
          },
          data: {
            timestamp: Date.now(),
            ...isFilter
          },
          success: (res: any) => {
            console.log('用户订阅信息', res)

            //单本订阅列表
            let singleArr: any = []

            for(let item of res.data.data.FreeProducts){

              for(let sec_item of item.Child){

                if(!singleArr.some((arr_item : any) => arr_item === sec_item)){
                  sec_item.isFree = 1
                  singleArr.push(sec_item)
                }
              }
            }

            for(let item of res.data.data.SubscribedProducts){

              for(let sec_item of item.Child){

                if(!singleArr.some((arr_item : any) => arr_item === sec_item)){
                  sec_item.isFree = 0
                  // sec_item.MallLink = item.MallLink || ''
                  singleArr.push(sec_item)
                }
              }
            }

            console.log('单本订阅列表', singleArr)
            setuserSubscribeSingleList(singleArr)

            //套装订阅列表
            let collectionArr: any = []
            for(let item of res.data.data.FreeProducts){
              if(!collectionArr.some((arr_item : any) => arr_item === item)){
                item.isFree = 1
                collectionArr.push(item)
              }
            }

            for(let item of res.data.data.SubscribedProducts){
              if(!collectionArr.some((arr_item : any) => arr_item === item)){
                item.isFree = 0
                collectionArr.push(item)
              }
            }

            console.log('套装订阅列表', collectionArr)
            setuserSubscribeCollectionList(collectionArr)
          }
        })
      }

    }
  }, [isFilter])

	// 消息推送授权
	const publicNotice = (callback) => {
    Taro.requestSubscribeMessage({
      tmplIds: ['F5kG9ryTuf3U09liOVIqqZDDEwNwiuWbLPPdoVpKPWI', 'cnMggWGwr0_cVw7Hf_fg3u74EDJdA0b4e56Ioy-Vr_Q'],
      success() {
        callback && callback()
      },
      fail() {
        callback && callback()
      },
    })
  }

  const requestUserSubscribe = () => {
    if (!Taro.getStorageSync('UserToken')) {
      publicNotice(() => {
        setuserSubscribeSingleList([])
        setuserSubscribeCollectionList([])
        setuserSubscribeSingleFreeCount(0)
        setuserSubscribeSinglePaidCount(0)
        setuserSubscribeCollectionFreeCount(0)
        setuserSubscribeCollectionPaidCount(0)

        setisLoginOpen(true)
      })
    }else{
      //查询用户订阅信息
      Taro.request({
        url: 'https://interapi.jm-kid.com/api/product/subscribed',
        method: 'POST',
        header: {
          authorization: 'bearer ' + Taro.getStorageSync('UserToken')
        },
        data: {
          timestamp: Date.now(),
          // filter: ''
        },
        success: (res: any) => {
          console.log('用户订阅信息', res)

          //单本订阅列表
          let singleArr: any = []

          //统计单本免费订阅数量
          let a: number = 0

          //统计套装免费订阅数量
          let b: number = 0

          //统计单本付费订阅数量
          let c: number = 0

          //统计套装付费订阅数量
          let d: number = 0

          for(let item of res.data.data.FreeProducts){

            b++

            for(let sec_item of item.Child){

              if(!singleArr.some((arr_item : any) => arr_item.PrdtId === sec_item.PrdtId)){
                sec_item.isFree = 1
                singleArr.push(sec_item)
                a++
              }
            }
          }

          for(let item of res.data.data.SubscribedProducts){

            d++

            for(let sec_item of item.Child){

              if(!singleArr.some((arr_item : any) => arr_item.PrdtId === sec_item.PrdtId)){
                sec_item.isFree = 0
                // sec_item.MallLink = item.MallLink || ''
                singleArr.push(sec_item)
                c++
              }
            }
          }

          console.log('单本订阅列表', singleArr)
          setuserSubscribeSingleList(singleArr)
          setuserSubscribeSingleFreeCount(a)
          setuserSubscribeSinglePaidCount(c)
          setuserSubscribeCollectionFreeCount(b)
          setuserSubscribeCollectionPaidCount(d)

          //套装订阅列表
          let collectionArr: any = []
          for(let item of res.data.data.FreeProducts){
            if(!collectionArr.some((arr_item : any) => arr_item.PrdtId === item.PrdtId)){
              item.isFree = 1
              collectionArr.push(item)
            }
          }

          for(let item of res.data.data.SubscribedProducts){
            if(!collectionArr.some((arr_item : any) => arr_item.PrdtId === item.PrdtId)){
              item.isFree = 0
              collectionArr.push(item)
            }
          }

          console.log('套装订阅列表', collectionArr)
          setuserSubscribeCollectionList(collectionArr)
        }
      })
    }
  }

  useDidShow(() => {
    if(Taro.getStorageSync('UserToken')){
      setisGetUsePhone(true)
    }
    requestUserSubscribe()
  })

  useDidHide(() => {
    setisGetUsePhone(false)
    setisLoginOpen(false)
  })

  useEffect(() => {
    if(isGetUsePhone){
      requestUserSubscribe()
    }
  }, [isGetUsePhone])

  const [userSelect, setuserSelect] = useState(0)

  // 生成关键字(id)二维码
  // useEffect(() => {
  //   Taro.request({
  //     url: 'https://api.weixin.qq.com/cgi-bin/token?grant_type=client_credential',
  //     data: {
  //       appid: 'wxc5c21dae2f45470e',
  //       secret: '599f2cf20740d630f06f447719653660',
  //     },
  //     success: function (res) {
  //       const access_token = res.data.access_token

  //       Taro.request({
  //         method: 'POST',
  //         url: 'https://api.weixin.qq.com/wxa/getwxacodeunlimit?access_token=' + access_token,
  //         data: {
  //           // check_path: 'false',
  //           // env_version: 'develop',
  //           scene: 'id=5390', //兑换码
  //           page: 'pages/UserHome/index' //需要跳转到的页面
  //         },
  //         responseType: 'arraybuffer',
  //         success: function (coderes) {
  //           //arraybuffer转base64
  //           console.log('64', Taro.arrayBufferToBase64(coderes.data))
  //         }
  //       })
  //     }
  //   })
  // }, [])

  const [isPopupOpen, setisPopupOpen] = useState(false)

  //管理跳转页面路径
  const [prdtMallLink, setprdtMallLink] = useState('')

  const [isToStoreOpen, setisToStoreOpen] = useState(false)

  const [userScene, setuserScene] = useState<any>(null)

  // 兑换成功弹窗
  const [isUserExchangeSuccessModalOpen, setisUserExchangeSuccessModalOpen] = useState(false)

  // 兑换接口返回的state
  const [exchangeState, setExchangeState] = useState('')

  // 兑换成功的商品名称字符串
  const [prdtNames, setPrdtNames] = useState('')

  // 兑换成功的商品名称数组
  const [prdtList, setPrdtList] = useState([])

  //唤起扫码
  const handleScanCode = () => {
    console.log('唤起扫码')
    Taro.scanCode({
      success: (res: any) => {
        console.log('二维码内容：', res)
        const { path } = res
        if(!Taro.getStorageSync('UserToken')){
          setisLoginOpen(true)
          setuserScene(path ? path.slice(-8) : '')
        }else{
          Taro.request({
            url: 'https://interapi.jm-kid.com/api/product/exchange',
            method: 'POST',
            header: {
              authorization: `bearer ${Taro.getStorageSync('UserToken')}`
            },
            data: {
              timestamp: Date.now(),
              change_code: path ? path.slice(-8) : ''
            },
            success: (s_res: any) => {
              const { state, data } = s_res.data
              setExchangeState(state)
              // 有返回商品名称，则显示；否则只显示提示语
              if(data && data.Subscribed){
                const list = data.Subscribed
                setPrdtNames(list.map((e: any) => e.PrdtTitle).join('；'))
                setPrdtList(list)
              }
              requestUserSubscribe()
              setisUserExchangeSuccessModalOpen(true)
            },
            fail: (err: any) => {
              console.log('兑换失败=>', err)
            }
          })
        }
      }
    })
  }

  //跳转套装详情页
  const handleToCollectionDetail = (item: any) => {
    if (item.SubscribedState === -1) {
      // 已过期，跳转商城
      setprdtMallLink(item.MallLink || '')
      setisToStoreOpen(true)
    } else {
      Taro.navigateTo({
        url: '/pages/CollectionDetail/index?id=' + item.PrdtId
      })
    }
  }

  // 套装删除
  const handleDelCollection = (item: any, e: TouchEvent) => {
    e.stopPropagation()
    if (item.SubscribedState === -1) {
      // 已过期，直接删除
      // debugger
      Taro.request({
        url: 'https://interapi.jm-kid.com/api/mark/subscribed',
        method: 'POST',
        header: {
          authorization: `bearer ${Taro.getStorageSync('UserToken')}`
        },
        data: {
          timestamp: Date.now(),
          prdt_id: item.PrdtId
        },
        success: () => {
          requestUserSubscribe()
        },
      })
    }
  }

  // 单本跳转详情
  const handleToSingleDetail = (item: any) => {
    if (item.SubscribedState === -1) {
      // 已过期，跳转商城
      setprdtMallLink(item.MallLink || '')
      setisToStoreOpen(true)
    } else {
      Taro.navigateTo({
        url: '/pages/SingleDetail/index?id=' + item.PrdtId
      })
    }
  }

  // 单本删除
  const handleDelSingle = (item: any, e: TouchEvent) => {
    e.stopPropagation()
    if (item.SubscribedState === -1) {
      debugger
      // 已过期，直接删除
      Taro.request({
        url: 'https://interapi.jm-kid.com/api/mark/subscribed',
        method: 'POST',
        header: {
          authorization: `bearer ${Taro.getStorageSync('UserToken')}`
        },
        data: {
          timestamp: Date.now(),
          prdt_id: item.ParentPrdtId
        },
        success: () => {
          requestUserSubscribe()
        },
      })
    }
  }

  const handleNavigateToMiniProgram = () => {
    Taro.navigateToMiniProgram({
      appId: 'wxbd3d383851fea776',
      path: 'pages/home/dashboard/index',
      success: (res) => {
        console.log('打开成功=>',res)
      },
      fail: (res) => {
        console.log('打开失败=>',res)
      }
    })
  }

  //键盘点击search开始检索
  const handleSearch = () => {
    const arr: any = []
    if(userSelect === 0){
      userSubscribeSingleList.forEach((item: any) => {
        if(item.PrdtTitle.includes(searchValue)){
          arr.push(item)
        }
      })
    }else if(userSelect === 1){
      userSubscribeCollectionList.forEach((item: any) => {
        if(item.PrdtTitle.includes(searchValue)){
          arr.push(item)
        }
      })
    }
    setsearchResult(arr)
    console.log('搜索结果=>', arr)
  }

  //搜索栏点击跳转搜索页
  const handleSearchToDetail = () => {
    if (!Taro.getStorageSync('UserToken')) {
      setisLoginOpen(true)
    }else{
      Taro.navigateTo({
        url: '/pages/SearchDetail/index'
      })
    }
  }

  return (
    <View className='subscribe_bg'>
      <View className='subscribe_header'>
        <View
          className='subscribe_header_searchContainer'
        >
        </View>
        <Input
          className='subscribe_header_input'
          placeholder='请输入绘本名称'
          value={searchValue}
          disabled
          confirmType='search'
          onConfirm={() => handleSearch()}
          onInput={(e) => {
            setsearchValue(e.detail.value)
          }}
          onClick={() => handleSearchToDetail()}
        ></Input>
        <View
          className='subscribe_header_dressing'
          onClick={() => setisPopupOpen(!isPopupOpen)}
        ></View>
        <Image
          className='subscribe_header_scanCodeBtn'
          src='https://oss.jm-kid.com/wx_5colorflower/scanCodeIcon.svg'
          onClick={handleScanCode}
        ></Image>
      </View>

      <View className='subscribe_selection'>
        <View
          className='subscribe_selection_item'
          style={userSelect === 0 ? {color: '#3ba366', fontSize: '1rem', height: '1rem', lineHeight: '1rem'} : {color: 'rgba(0, 0, 0, .3)', fontSize: '.875rem', height: '.875rem', lineHeight: '.875rem'}}
          onClick={()=>{setuserSelect(0)}}
        >
          <Text className='subscribe_selection_item_text'>单本</Text>
        </View>
        <View
          className='subscribe_selection_item'
          style={userSelect === 1 ? {color: '#3ba366', fontSize: '1rem', height: '1rem', lineHeight: '1rem'} : {color: 'rgba(0, 0, 0, .3)', fontSize: '.875rem', height: '.875rem', lineHeight: '.875rem'}}
          onClick={()=>{setuserSelect(1)}}
        >
          <Text className='subscribe_selection_item_text'>套装</Text>
        </View>
      </View>

      {/* 列表渲染 */}
      {
        isGetUsePhone &&
        <ScrollView
          scrollY
          scrollWithAnimation
          className={`subscribe_content ${!userSubscribeSingleList.length && !userSubscribeCollectionList.length ? 'empty' : ''}`}
          enableFlex
        >
          <View
            className='subscribe_container'
            style={userSelect === 0 ? {gridTemplateColumns: 'repeat(3, 1fr)'} : {gridTemplateColumns: 'repeat(2, 1fr)'}}
          >
            {
              userSelect === 0 && userSubscribeSingleList.length > 0 && userSubscribeSingleList.map((item: any, index: number) => (
                <View
                  className='subscribe_content_singleItem'
                  key={index}
                  onClick={() => handleToSingleDetail(item)}
                >
                <View className='cover_wrap'>
                  <Image
                    className='subscribe_content_singleItem_cover'
                    src={item.PrdtCover}
                    mode='widthFix'
                    lazyLoad
                  ></Image>
                    {
                      item.SubscribedState === -1 && (
                        <View className='expire'>
                          <Image src='https://oss.jm-kid.com/wx_5colorflower/error.png' className='expire_icon' onClick={(e) => handleDelSingle(item, e)}></Image>
                          <View className='expire_text'>已 过 期</View>
                        </View>
                      )
                    }
                    {
                      item.isFree === 1 && <Text className='subscribe_content_singleItem_label'>免费绘本</Text>
                    }
                    {
                      item.OrdRefer === 3 && <Text className='subscribe_content_singleItem_label'>免费赠送</Text>
                    }
                  </View>

                  <View className='subscribe_content_singleItem_title'>{item.PrdtTitle}</View>
                </View>
              ))
            }

            {
              userSelect === 1 && userSubscribeCollectionList.length > 0 && userSubscribeCollectionList.map((item: any, index: number) => (
                <View
                  className='subscribe_content_collectionItem'
                  key={index}
                  onClick={() => handleToCollectionDetail(item)}
                >
                  <View className='cover_wrap'>
                    <Image
                      className='subscribe_content_singleItem_cover'
                      src={item.PrdtCover}
                      mode='widthFix'
                      lazyLoad
                    ></Image>
                    {
                      item.SubscribedState === -1 && (
                        <View className='expire'>
                          <Image src='https://oss.jm-kid.com/wx_5colorflower/error.png' className='expire_icon' onClick={(e) => handleDelCollection(item, e)}></Image>
                          <View className='expire_text'>已 过 期</View>
                        </View>
                      )
                    }
                    {
                      item.isFree === 1 && <Text className='subscribe_content_singleItem_label'>免费绘本</Text>
                    }
                    {
                      item.OrdRefer === 3 && <Text className='subscribe_content_singleItem_label'>免费赠送</Text>
                    }
                  </View>
                  <View className='subscribe_content_singleItem_title'>{item.PrdtTitle}</View>
                  <View className='subscribe_content_collectionItem_count'>{`共${item.ChildCount}本`}</View>
                </View>
              ))
            }

            {
              isGetUsePhone && (!isFilter || isFilter === 'reset') && <View
                className='subscribe_content_singleItem_add'
                onClick={()=>{setisToStoreOpen(true)}}
              >
                <View className='subscribe_content_singleItem_addLabel'></View>
              </View>
            }
          </View>

          {/* 跳转商城 */}
          <GoToStoreModal
            visible={isToStoreOpen}
            onClose={() => setisToStoreOpen(false)}
            type={1}
            mallLink={prdtMallLink}
            setmallLink={setprdtMallLink}
          ></GoToStoreModal>
        </ScrollView>
      }


      {
        isGetUsePhone && (!isFilter || isFilter === 'reset') &&
        <View className='subscribe_footer'>
          <Text className='subscribe_footer_tips'>
            {
              userSelect === 0 ? `${userSubscribeSingleFreeCount}本免费绘本，${userSubscribeSinglePaidCount}本订阅绘本 ` : `${userSubscribeCollectionFreeCount}套免费绘本，${userSubscribeCollectionPaidCount}套订阅绘本 `
            }
          </Text>
          <Text
            className='subscribe_footer_add'
            onClick={handleNavigateToMiniProgram}
          >
            订阅更多绘本
          </Text>
        </View>
      }

      {
        isGetUsePhone && userSelect === 0 && userSubscribeSingleList.length === 0 &&
        <DefaultPage3></DefaultPage3>
      }

      {
        isGetUsePhone && userSelect === 1 && userSubscribeCollectionList.length === 0 &&
        <DefaultPage3></DefaultPage3>
      }


      {/* 用户未登录 */}
      {
        !isGetUsePhone &&
        <DefaultPage1
          setisGetUsePhone={setisGetUsePhone}
        ></DefaultPage1>
      }

      <Gift />

      <PopupHalfScreen
        visible={isPopupOpen}
        onClose={() => setisPopupOpen(!isPopupOpen)}
        onFilter={setisFilter}
      ></PopupHalfScreen>

      <GetPhoneNumber
        onClose={setisGetUsePhone}
        scene={userScene}
        modalVisible={isLoginOpen}
        onModalClose={() => setisLoginOpen(false)}
      ></GetPhoneNumber>

      <UserExchangeSuccessModal exchangeState={exchangeState} prdtList={prdtList} prdtNames={prdtNames} isOpen={isUserExchangeSuccessModalOpen} setIsOpen={setisUserExchangeSuccessModalOpen}></UserExchangeSuccessModal>
    </View>
  )
}
