import { ScrollView, View, Text } from '@tarojs/components'
import React, { useState } from 'react'
import Taro, { useDidShow, useShareAppMessage, useShareTimeline } from '@tarojs/taro'
import './index.less'

interface subscribeProps {
  OrdDate: string,
  OrdRefer: number,
  PrdtCover: string,
  PrdtDeadline: string,
  PrdtId: number,
  PrdtSubtitle: string,
  PrdtTitle: string,
}

export default function UserMessage() {

  useShareAppMessage((res) => {
    if (res.from === 'button') {
      console.log(res.target);
    }
    return {
      title: '五色花',
      path: '/pages/Home/index'
    }
  })

  useShareTimeline(() => {
    return {
      title: '五色花',
      path: '/pages/Home/index'
    }
  })

  const [userSubuscribed, setuserSubuscribed] = useState<subscribeProps[]>()

  useDidShow(() => {
    Taro.request({
      url: 'https://interapi.jm-kid.com/api/message/list',
      method: 'POST',
      header: {
        authorization: `bearer ${Taro.getStorageSync('UserToken')}`,
      },
      data: {
        timestamp: Date.now(),
      },
      success: (res: any) => {
        console.log('消息列表查询成功=>', res.data)
        setuserSubuscribed(res.data.data)
      }
    })
  })

  //跳转详情页
  const handleDetailClick = (item: any) => {
    if (item.read_at) {
      toDetail(item)
    } else {
      // 标记已读
      Taro.request({
        url: 'https://interapi.jm-kid.com/api/message/mark',
        method: 'POST',
        header: {
          authorization: `bearer ${Taro.getStorageSync('UserToken')}`,
        },
        data: {
          timestamp: Date.now(),
          operate: 'read',
          msg_id: item.msg_id
        },
        success: () => {
          toDetail(item)
        }
      })
    }
  }

  //跳转详情页
  const toDetail = (item: any) => {
    if (item.link) {
      Taro.navigateTo({
        url: `/pages/CollectionDetail/index?id=${item.link.prdt_id}`
      })
    } else {
      Taro.switchTab({
        url: '/pages/Home/index',
      })
    }
  }

  return (
    <View className='subscribe_bg'>
      {
        userSubuscribed && userSubuscribed.length ?
        <View>
          {
            userSubuscribed.map((item: any, index: number) => (
              <View
                className='subscribe_item'
                key={index}
                onClick={()=>handleDetailClick(item)}
              >
                <View className='item_header'>
                  <Text className='item_header_title'>{item.title}</Text>
                  <Text className='item_header_date'>{item.created_at}</Text>
                  { !item.read_at && <View className='item_header_dot'></View> }
                </View>
                <View className='item_content'>
                  <Text className='item_des'>{item.content}</Text>
                  <Text className='item_link'>立即查看&gt; &gt;</Text>
                  <View></View>
                </View>
              </View>
            ))
          }
        </View> :
        <View className='none'>暂无消息~</View>
      }
    </View>
  )
}
