
import { useEffect, useState } from 'react'
import { Button, Image, Input, View, Text } from '@tarojs/components'
import Taro, { useShareAppMessage, useShareTimeline } from '@tarojs/taro'
import './index.less'

export default function UserPersonalInfo() {

  useShareAppMessage((res) => {
    if (res.from === 'button') {
      console.log(res.target);
    }
    return {
      title: '五色花',
      path: '/pages/Home/index'
    }
  })

  useShareTimeline(() => {
    return {
      title: '五色花',
      path: '/pages/Home/index'
    }
  })

  const [userAvatar, setuserAvatar] = useState(
    Taro.getStorageSync('UserAvatar') ? Taro.getStorageSync('UserAvatar') : ''
  )

  const [userNickname, setuserNickname] = useState(
    Taro.getStorageSync('UserNickName') ? Taro.getStorageSync('UserNickName') : ''
  )
  const [userPhoneNumber, setuserPhoneNumber] = useState(
    Taro.getStorageSync('UserPhoneNumber') ? Taro.getStorageSync('UserPhoneNumber') : ''
  )

  const [isChangeAvatar, setisChangeAvatar] = useState(false)

  useEffect(()=> {
    console.log('用户昵称=>', userNickname)
    console.log('用户头像=>', userAvatar)
    // setuserNickname('123123123312')
    //将用户手机号第四位到第八位隐藏
    setuserPhoneNumber(userPhoneNumber.slice(0,3) + '****' + userPhoneNumber.slice(7))
  }, [userPhoneNumber])

  const handleChooseAvatar = (e: any) => {
    //回调用户头像地址
    console.log(e.detail.avatarUrl)
    setisChangeAvatar(true)
    setuserAvatar(e.detail.avatarUrl)
  }

  const handleSave = () => {

    console.log('userAvatar=>', userAvatar)
    if(isChangeAvatar){
      Taro.uploadFile({
        url: 'https://interapi.jm-kid.com/api/user/edit',
        header: {
          authorization: `bearer ${Taro.getStorageSync('UserToken')}`
        },
        filePath: userAvatar,
        name: 'avatar',
        formData: {
          timestamp: Date.now(),
          nick_name: userNickname,
          access_token: Taro.getStorageSync('UserToken'),
          avatar: userAvatar,
        },
        success: (res: any) => {
          console.log('保存成功=>', JSON.parse(res.data))
          Taro.showToast({
            title: '保存成功',
            icon: 'success',
            duration: 2000
          })
          Taro.setStorageSync('UserAvatar', JSON.parse(res.data).data.user.Avatar)
          Taro.setStorageSync('UserNickName', JSON.parse(res.data).data.user.NickName)

          setisChangeAvatar(false)
          // Taro.navigateBack()
        }
      })
    }else{
      Taro.request({
        method: 'POST',
        url: 'https://interapi.jm-kid.com/api/user/edit',
        header: {
          authorization: `bearer ${Taro.getStorageSync('UserToken')}`
        },
        data: {
          timestamp: Date.now(),
          nick_name: userNickname,
        },
        success: (res: any) => {
          console.log('保存成功=>', res.data)
          Taro.showToast({
            title: '保存成功',
            icon: 'success',
            duration: 2000
          })
          Taro.setStorageSync('UserNickName', res.data.data.user.NickName)

          setisChangeAvatar(false)
          // Taro.navigateBack()0000
        }
      })
    }

  }

  // 退出登录
  const logout = () => {
    try {
      Taro.clearStorageSync()
      Taro.switchTab({
        url: '/pages/Home/index',
      })
    } catch (e) {}
  }

  return (
    <View className='info_bg'>
      <View className='info_header'>
        <Button
          openType='chooseAvatar'
          className='info_avatar'
          onChooseAvatar={handleChooseAvatar}
        >
          <Image
            src={userAvatar}
            mode='aspectFill'
            className='info_avatar_img'
          ></Image>
        </Button>
      </View>
      <View className='info_content'>
        <View className='info_content_item'>
          <Text className='info_content_item_title'>昵称</Text>
          <Input
            className='info_content_item_input'
            value={userNickname}
            onInput={(e)=>{setuserNickname(e.detail.value)}}
            placeholder='name'
          ></Input>
        </View>
        <View className='info_content_item'>
          <Text className='info_content_item_title'>手机号</Text>
          <Input
            className='info_content_item_input phone'
            value={userPhoneNumber}
            disabled
          ></Input>
        </View>
      </View>
      <View
        className='info_content_btn'
        onClick={handleSave}
      >
        <Text
          className='info_content_btn_text'
        >保存</Text>
      </View>
      <View
        className='info_content_btn logout'
        onClick={logout}
      >
        <Text
          className='info_content_btn_text'
        >退出登录</Text>
      </View>
    </View>
  )
}
